;
; This file is a template to begin developing Avigo Applications
;
;
;
SCALL1	.EQU	$000F				;This is some system call
XTOP	.EQU	$8010
YTOP	.EQU	$8011
XBOT:	.EQU	$8012
YBOT:	.EQU	$8013
HORIZP  .EQU	$8014
VERTP   .EQU	$8015
BCOUNT  .EQU	$8016
LCOUNT  .EQU	$8017
SHFLAG  .EQU	$8018
;
POINTER .EQU	$801A
MEMPNTR .EQU	$801C
OFFSET  .EQU	$801E
SCANNR  .EQU	$8020
BUFFER  .EQU	$8022


;
;
	.ORG    $4000				;Start at $4000H
;
		JP	START			;Go to the starting code
;
	.ORG    $4003	
	.byte	"RBroniak 1997",0,0,0		;16 Bytes of copyright information
;
	.ORG    $4013	
	.byte	"PDE 2.00        "		;16 Bytes of OTHER information
;
	.ORG    $4023	
	.byte	02H				;Access program from apps screen
						;Change to 01 for menu access
;
	.ORG    $4024	
	.byte	0B0H,55H			;Data for something?
;
	.ORG    $4026	
	.byte	60H,0CH,09H			;** Creation date
						; 60H = 1997
						; 0CH = Month of DECEMBER
						; 09H = Date of 9th
;
	.ORG    $4029	
	.byte	0DH,20H,38H			;Data for something?
;
	.ORG    $402C	
	.byte	"Memory Show",0,0,0,0,0		;16 Bytes for Application Name
;
	.ORG    $403C	
	.byte	01H,00H				;Version Number MSB.LSB
						;eg: ver 1.00	
;	
	.ORG    $403E	
	.byte	10H,00H				;Data for something?
;
	.ORG    $4040	
	.byte	10H				;Amount of data to transmit
						; 10H = 1x16 = 16k of data
						; 50H = 5x16 = 80k of data
;
	.ORG    $4041	
	.byte	00H,50H,0AAH			;Data for something?
;
	.ORG    $4044	
	.byte	34H,32H				;ICON dimensions MSB x LSB (52x50)
	.byte	00H				;Terminator
;
	.ORG    $4047

;
	.byte  00H, 00H, 00H, 00H, 00H, 00H, 00H 	;ICON Data  350 Bytes 
	.byte  00H, 00H, 00H, 00H, 00H, 00H, 00H	;7 Bytes x 50 lines
	.byte  00H, 00H, 00H, 00H, 00H, 00H, 00H
	.byte  00H, 00H, 0FFH, 0FFH, 00H, 00H, 00H
	.byte  00H, 00H, 80H, 03H, 80H, 00H, 00H
	.byte  00H, 00H, 80H, 02H, 0C0H, 00H, 00H
	.byte  00H, 00H, 80H, 02H, 60H, 00H, 00H
	.byte  00H, 00H, 0FFH, 0E2H, 30H, 00H, 00H
;
	.byte  00H, 00H, 80H, 02H, 18H, 00H, 00H
	.byte  00H, 00H, 80H, 02H, 0CH, 00H, 00H
	.byte  00H, 00H, 80H, 03H, 0FCH, 00H, 00H
	.byte  00H, 00H, 0FFH, 0E0H, 04H, 00H, 00H
	.byte  00H, 00H, 80H, 00H, 04H, 00H, 00H
	.byte  00H, 00H, 80H, 00H, 04H, 00H, 00H
	.byte  00H, 00H, 80H, 00H, 04H, 00H, 00H
	.byte  00H, 00H, 0FFH, 0FEH, 04H, 00H, 00H,
;
	.byte  00H, 00H, 80H, 00H, 04H, 00H, 00H
	.byte  00H, 00H, 80H, 00H, 04H, 00H, 00H
	.byte  00H, 00H, 80H, 00H, 04H, 00H, 00H
	.byte  00H, 00H, 0FFH, 0FEH, 04H, 00H, 00H
	.byte  00H, 00H, 80H, 00H, 04H, 00H, 00H
	.byte  00H, 00H, 80H, 00H, 04H, 00H, 00H
	.byte  00H, 00H, 80H, 00H, 04H, 00H, 00H
	.byte  00H, 00H, 0FFH, 0FEH, 04H, 00H, 00H
;
	.byte  00H, 00H, 80H, 00H, 04H, 00H, 00H
	.byte  00H, 00H, 80H, 00H, 04H, 00H, 00H
	.byte  00H, 00H, 80H, 00H, 04H, 00H, 00H
	.byte  00H, 00H, 0FFH, 0FEH, 04H, 00H, 00H
	.byte  00H, 00H, 80H, 00H, 04H, 00H, 00H
	.byte  00H, 00H, 80H, 00H, 04H, 00H, 00H
	.byte  00H, 00H, 80H, 00H, 04H, 00H, 00H
	.byte  00H, 00H, 0FFH, 0FFH, 0FCH, 00H, 00H
;
	.byte  00H, 00H, 00H, 00H, 00H, 00H, 00H
	.byte  00H, 41H, 00H, 00H, 00H, 00H, 00H
	.byte  00H, 63H, 00H, 00H, 00H, 00H, 00H
	.byte  00H, 63H, 33H, 0F1H, 8DH, 10H, 00H
	.byte  00H, 55H, 4AH, 4AH, 50H, 0A0H, 00H
	.byte  00H, 55H, 7AH, 4AH, 50H, 0A0H, 00H
	.byte  00H, 55H, 42H, 4AH, 50H, 0A0H, 00H
	.byte  00H, 49H, 3AH, 49H, 90H, 40H, 00H
;
	.byte  00H, 00H, 00H, 00H, 00H, 40H, 00H
	.byte  00H, 00H, 0E4H, 00H, 00H, 80H, 00H
	.byte  00H, 01H, 14H, 00H, 00H, 00H, 00H
	.byte  00H, 01H, 07H, 19H, 24H, 00H, 00H
	.byte  00H, 00H, 0E4H, 0A5H, 54H, 00H, 00H
	.byte  00H, 00H, 14H, 0A5H, 54H, 00H, 00H
	.byte  00H, 01H, 14H, 0A5H, 54H, 00H, 00H
	.byte  00H, 00H, 0E4H, 98H, 88H, 00H, 00H
;
	.byte  00H, 00H, 00H, 00H, 00H, 00H, 00H
	.byte  00H, 00H, 00H, 00H, 00H, 00H, 00H
;
	.byte	0FFH,0FFH,0FFH,0FFH		;Blank space?
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
;
;
;This is the start of the program code...
;
START:	CALL	CLRSCN
;
	LD	A,$0D				;SET INVERSE LINE AT THE TOP
	LD	(YBOT),A			;16 PIXELS HIGH
	LD	A,$A0				;160 PIXELS ACROSS
	LD	(XBOT),A
	LD	A,$01				;2ND PIXEL LINE
	LD	(YTOP),A
	LD	A,$00				;FOR THE WHOLE LINE
	LD	(XTOP),A
	LD	A,$01				;TURN PIXELS ON
	CALL	CLRP0
;
	LD      L,$01				;SET BOLD TYPE                 
        CALL    $00D5                 
	LD	HL,TITLE			;SHOW THE TITLE
	LD	(POINTER),HL
	LD	A,2
	LD	(YTOP),A
	LD	A,8			
	LD	(XTOP),A
	LD	A,$01				;SET INVERSE TYPE
	CALL	PUTS0
;
	LD	HL,MS01				;SHOW FIRST LINE AT BOTTOM
	LD	(POINTER),HL
	LD	A,$DB
	LD	(YTOP),A
	LD	A,8			
	LD	(XTOP),A
	CALL	PUTSCR
;
	LD	HL,MS02				;SHOW SECOND LINE AT BOTTOM
	LD	(POINTER),HL
	LD	A,$E4
	LD	(YTOP),A
	LD	A,8			
	LD	(XTOP),A
	CALL	PUTSCR
;

	LD	A,$D8				;SET INVERSE LINE AT THE BOTTOM
	LD	(YBOT),A			;1 PIXEL HIGH
	LD	A,$A0				;160 PIXELS ACROSS
	LD	(XBOT),A
	LD	A,$D8				
	LD	(YTOP),A
	LD	A,$00				;FOR THE WHOLE LINE
	LD	(XTOP),A
	LD	A,$01				;TURN PIXELS ON
	CALL	CLRP0
;
	LD	HL,$4000
	LD	(MEMPNTR),HL
	LD	A,$00
	LD	(SHFLAG),A
	LD	HL,$0080
	LD	(OFFSET),HL
SH06:	LD	A,$00
	LD	(LCOUNT),A
	LD	A,$0F			;INIT POINTERS
	LD	(VERTP),A
	CALL	SHOWOFF
SH02:	LD	A,$01
	LD	(HORIZP),A

;			
	LD	IY,BUFFER		;SHOW MSB OF POINTER
	LD	A,(MEMPNTR+1)
	AND	$0F
	LD	D,$00
	LD	E,A
	LD	IX,HEXTABLE
	ADD	IX,DE
	LD	A,(IX+0)
	LD	(IY+1),A
	XOR	A
	LD	A,(MEMPNTR+1)
	AND	$F0
	RRA
	RRA
	RRA
	RRA
	LD	D,$00
	LD	E,A
	LD	IX,HEXTABLE
	ADD	IX,DE
	LD	A,(IX+0)
	LD	(IY+0),A

	LD	A,(MEMPNTR)		;SHOW LSB OF POINTER
	AND	$0F
	LD	D,$00
	LD	E,A
	LD	IX,HEXTABLE
	ADD	IX,DE
	LD	A,(IX+0)
	LD	(IY+3),A
	XOR	A
	LD	A,(MEMPNTR)
	AND	$F0
	RRA
	RRA
	RRA
	RRA
	LD	D,$00
	LD	E,A
	LD	IX,HEXTABLE
	ADD	IX,DE
	LD	A,(IX+0)
	LD	(IY+2),A
	LD	A,$20
	LD	(IY+4),A
	LD	A,$00
	LD	(IY+5),A

	LD	HL,BUFFER		;SHOW MEMORY LOCATION
	LD	(POINTER),HL
	LD	A,(VERTP)
	LD	(YTOP),A
	LD	A,(HORIZP)			
	LD	(XTOP),A
	CALL	PUTSCR

	LD	A,$1E
	LD	(HORIZP),A
	LD	A,$00
	LD	(BCOUNT),A


	LD	HL,(MEMPNTR)
SH01:	LD	IY,BUFFER	
	LD	A,(HL)
	AND	$0F
	LD	D,$00
	LD	E,A
	LD	IX,HEXTABLE
	ADD	IX,DE
	LD	A,(IX+0)
	LD	(IY+1),A
	XOR	A
	LD	A,(HL)
	AND	$F0
	RRA
	RRA
	RRA
	RRA
	LD	D,$00
	LD	E,A
	LD	IX,HEXTABLE
	ADD	IX,DE
	LD	A,(IX+0)
	LD	(IY+0),A
	LD	A,$20
	LD	(IY+2),A
	LD	A,$00
	LD	(IY+3),A
	LD	A,(SHFLAG)
	CP	$01
	JR	NZ,SH07
;
	XOR	A
	LD	A,(HL)
	CP	$00
	JR	NZ,SH11
	LD	A,$2E
SH11:	LD	(IY+0),A
	LD	A,$20
	LD	(IY+1),A
	LD	(IY+2),A	
	LD	(IY+3),A
	LD	A,$00
	LD	(IY+4),A
;
SH07:	LD	HL,BUFFER		;SHOW MEMORY BYTE
	LD	(POINTER),HL
	LD	A,(VERTP)
	LD	(YTOP),A
	LD	A,(HORIZP)			
	LD	(XTOP),A
	CALL	PUTSCR


	LD	A,(HORIZP)
	ADD	A,$0E	
	LD	(HORIZP),A
	LD	HL,(MEMPNTR)
	LD	A,(BCOUNT)
	INC	A
	LD	(BCOUNT),A
	LD	D,$00
	LD	E,A
	ADD	HL,DE
	CP	$08
	JP	NZ,SH01	

	LD	D,$00
	LD	E,$08
	LD	HL,(MEMPNTR)
	ADD	HL,DE
	LD	(MEMPNTR),HL
	LD	A,(VERTP)
	LD	E,$0B
	ADD	A,E
	LD	(VERTP),A
	LD	A,(LCOUNT)
	INC	A
	LD	(LCOUNT),A
	CP	$12
	JP	NZ,SH02

SH05:	CALL    GETKEY
	CP	$FF
	JP	Z,THE_END
	CP	$06
	JR	Z,SH03
	CP	$07
	JR	Z,SH04
	CP	$04
	JR	Z,SH08
	CP	$05
	JR	Z,SH09
	CP	$03
	JR	Z,SH12
	CP	$02
	JR	NZ,SH05
	JP	THE_END
;
SH03:	LD	A,$00
	XOR	A
	LD	HL,(OFFSET)
	LD	D,H
	LD	E,L
	LD	HL,(MEMPNTR)
	SBC	HL,DE
	LD	DE,$0090
	LD	A,$00
	XOR	A
	SBC	HL,DE
	LD	(MEMPNTR),HL
	JP	SH06
;
SH04:	LD	A,$00
	XOR	A
	LD	HL,(OFFSET)
	LD	D,H
	LD	E,L
	LD	HL,(MEMPNTR)
	ADC	HL,DE
	LD	A,$00
	XOR	A
	LD	DE,$0090
	SBC	HL,DE
	LD	(MEMPNTR),HL
	JP	SH06
;
SH09:	LD	A,$01
	JR	SH10
SH08:	LD	A,$00
SH10:	LD	(SHFLAG),A
	LD	A,$00
	AND	$00
	LD	HL,(MEMPNTR)
	LD	DE,$0090
	SBC	HL,DE
	LD	(MEMPNTR),HL
	JP	SH06
;
SH12:	LD	HL,(OFFSET)
	LD	A,L
	CP	$80
	JR	Z,SH15
	LD	A,H
	CP	$04
	JR	Z,SH16
	CP	$10
	JR	Z,SH17
	CP	$40
	JR	Z,SH18
SH19:	LD	A,$00
	AND	$00
	LD	HL,(MEMPNTR)
	LD	DE,$0090
	SBC	HL,DE
	LD	(MEMPNTR),HL
	JP	SH06
;
SH15:	LD	HL,$0400
	LD	(OFFSET),HL
	JR	SH19
SH16:	LD	HL,$1000
	LD	(OFFSET),HL
	JR	SH19
SH17:	LD	HL,$4000
	LD	(OFFSET),HL
	JR	SH19
SH18:	LD	HL,$0080
	LD	(OFFSET),HL
	JR	SH19
;
SHOWOFF:

	LD	IY,BUFFER		;SHOW MSB OF OFFSET
	LD	A,(OFFSET+1)
	AND	$0F
	LD	D,$00
	LD	E,A
	LD	IX,HEXTABLE
	ADD	IX,DE
	LD	A,(IX+0)
	LD	(IY+2),A
	XOR	A
	LD	A,(OFFSET+1)
	AND	$F0
	RRA
	RRA
	RRA
	RRA
	LD	D,$00
	LD	E,A
	LD	IX,HEXTABLE
	ADD	IX,DE
	LD	A,(IX+0)
	LD	(IY+1),A

	LD	A,(OFFSET)		;SHOW LSB OF OFFSET
	AND	$0F
	LD	D,$00
	LD	E,A
	LD	IX,HEXTABLE
	ADD	IX,DE
	LD	A,(IX+0)
	LD	(IY+4),A
	XOR	A
	LD	A,(OFFSET)
	AND	$F0
	RRA
	RRA
	RRA
	RRA
	LD	D,$00
	LD	E,A
	LD	IX,HEXTABLE
	ADD	IX,DE
	LD	A,(IX+0)
	LD	(IY+3),A
	LD	A,$00
	LD	(IY+5),A
	LD	A,$24
	LD	(IY+0),A

	LD      L,$01			;SET BOLD TYPE                 
        CALL    $00D5  
	LD	HL,BUFFER		;SHOW OFFSET IN TITLE BAR
	LD	(POINTER),HL
	LD	A,$02
	LD	(YTOP),A
	LD	A,$75			
	LD	(XTOP),A
	LD	A,$01			;SET INVERSE TYPE
	CALL	PUTS0
	RET
;
THE_END	
	CALL	PUTBOX
;
	LD	L,$21
	CALL	$00D5
	LD	HL,MS03			
	LD	(POINTER),HL
	LD	A,$2C
	LD	(YTOP),A
	LD	A,$43
	LD	(XTOP),A	
	CALL	PUTSCR
;
	LD	L,$21
	CALL	$00D5
	LD	HL,MS07			
	LD	(POINTER),HL
	LD	A,$37
	LD	(YTOP),A
	LD	A,$43
	LD	(XTOP),A	
	CALL	PUTSCR

;
	LD	L,$20
	CALL	$00D5
	LD	HL,MS04			
	LD	(POINTER),HL
	LD	A,$46
	LD	(YTOP),A
	LD	A,$18
	LD	(XTOP),A	
	CALL	PUTSCR

	LD	L,$20
	CALL	$00D5
	LD	HL,MS05			
	LD	(POINTER),HL
	LD	A,$53
	LD	(YTOP),A
	LD	A,$18
	LD	(XTOP),A	
	CALL	PUTSCR
	LD	L,$20
	CALL	$00D5

	LD	L,$20
	CALL	$00D5
	LD	HL,MS06			
	LD	(POINTER),HL
	LD	A,$68
	LD	(YTOP),A
	LD	A,$18
	LD	(XTOP),A	
	CALL	PUTSCR

END1:	CALL	CHECK_OK
	CP	$00
	JR	Z,END1
	RET

;

;
;********************************************
;  -----------------------------------------
;  A V I G O - System routines Identified!!!
;  -----------------------------------------
;********************************************
;
;------------------------------------------------------------------------------------
;	This routine will clear the avigo screen
;------------------------------------------------------------------------------------
;
CLRSCN: LD      L,$00           
CLRS0:  CALL    $0093                  
	RET
;
;------------------------------------------------------------------------------------
;	This routine will clear/set a single
;	pixel on the Avigo screen
;------------------------------------------------------------------------------------
;
SET1PIX: LD      A,$00                   ; 13E4 3E00     >.	;TURN PIXEL ON = $00
         LD      L,A                     ; 13E6 6F       o	;TURN PIXEL OFF = $01
         LD      H,$00                   ; 13E7 2600     &.
         PUSH    HL                      ; 13E9 E5       .
	 LD	 A,(YTOP)
         LD      E,A                     ; 0734 1E00     ..	;Y POSITION OF PIXEL
	 LD	 A,(XTOP)
         LD      L,A                     ; 0736 2E0E     ..	;X POSITION OF PIXEL
         CALL    $00B4                   ; 13F1 CDB400   ...
         POP     BC                      ; 13F4 C1       .
	 RET
;
;------------------------------------------------------------------------------------
;	This routine will clear a certain area
;	of pixels within the Avigo screen
;------------------------------------------------------------------------------------
;

CLRPIX: LD      A,$00                   ; 06FF 3E00     >.	;TURN PIXELS OFF = 00
CLRP0:  LD      L,A                     ; 0701 6F       o	;TURN PIXELS ON = 01
        LD      H,$00                   ; 0702 2600     &.
        PUSH    HL                      ; 0704 E5       .
        LD      A,(YBOT)                ; 0705 3E0C     >.	;Y POSITION OF LOWER RH PIXEL?
        LD      L,A                     ; 0707 6F       o
        LD      H,$00                   ; 0708 2600     &.
        PUSH    HL                      ; 070A E5       .	
        LD      A,(XBOT)                ; 070E 7D       }	;X POSITION OF LOWER RH PIXEL?
        LD      L,A                     ; 070F 6F       o
        LD      H,$00                   ; 0710 2600     &.
        PUSH    HL                      ; 0712 E5       .
	LD	A,(YTOP)
        LD      E,A                     ; 0713 1E00     ..	;Y POSITION OF UPPER LH PIXEL?
	LD	A,(XTOP)
        LD      L,A                     ; 0715 2E00     ..	;X POSITION OF UPPER LH PIXEL?
        CALL    $0096                   ; 0717 CD9600   ...
        POP     BC                      ; 071A C1       .
        POP     BC                      ; 071B C1       .
        POP     BC                      ; 071C C1       .
	RET
;
;------------------------------------------------------------------------------------
DRAW_GREY: 
	LD      A,$01                   ; 06FF 3E00     >.	;TURN PIXELS OFF = 00
 	LD      L,A                     ; 0701 6F       o	;TURN PIXELS ON = 01
        LD      H,$00                   ; 0702 2600     &.
        PUSH    HL                      ; 0704 E5       .
        LD      A,(YBOT)                ; 0705 3E0C     >.	;Y POSITION OF LOWER RH PIXEL?
        LD      L,A                     ; 0707 6F       o
        LD      H,$00                   ; 0708 2600     &.
        PUSH    HL                      ; 070A E5       .	
        LD      A,(XBOT)                ; 070E 7D       }	;X POSITION OF LOWER RH PIXEL?
        LD      L,A                     ; 070F 6F       o
        LD      H,$00                   ; 0710 2600     &.
        PUSH    HL                      ; 0712 E5       .
	LD	A,(YTOP)
        LD      E,A                     ; 0713 1E00     ..	;Y POSITION OF UPPER LH PIXEL?
	LD	A,(XTOP)
        LD      L,A                     ; 0715 2E00     ..	;X POSITION OF UPPER LH PIXEL?
        CALL    $00AE                   ; 0717 CD9600   ...
        POP     BC                      ; 071A C1       .
        POP     BC                      ; 071B C1       .
        POP     BC                      ; 071C C1       .
	RET
;
;------------------------------------------------------------------------------------
INVERT_PIX: 
	LD      A,$00                   ; 06FF 3E00     >.	;TURN PIXELS OFF = 00
 	LD      L,A                     ; 0701 6F       o	;TURN PIXELS ON = 01
        LD      H,$00                   ; 0702 2600     &.
        PUSH    HL                      ; 0704 E5       .
        LD      A,(YBOT)                ; 0705 3E0C     >.	;Y POSITION OF LOWER RH PIXEL?
        LD      L,A                     ; 0707 6F       o
        LD      H,$00                   ; 0708 2600     &.
        PUSH    HL                      ; 070A E5       .	
        LD      A,(XBOT)                ; 070E 7D       }	;X POSITION OF LOWER RH PIXEL?
        LD      L,A                     ; 070F 6F       o
        LD      H,$00                   ; 0710 2600     &.
        PUSH    HL                      ; 0712 E5       .
	LD	A,(YTOP)
        LD      E,A                     ; 0713 1E00     ..	;Y POSITION OF UPPER LH PIXEL?
	LD	A,(XTOP)
        LD      L,A                     ; 0715 2E00     ..	;X POSITION OF UPPER LH PIXEL?
        CALL    $0099                   ; 0717 CD9600   ...
        POP     BC                      ; 071A C1       .
        POP     BC                      ; 071B C1       .
        POP     BC                      ; 071C C1       .
	RET
;------------------------------------------------------------------------------------
;	This routine will DRAW a line from X,Y (Upper LH) 
;	to X,Y (Lower RH) pixels on the Avigo screen
;
;       CALL    $0099           ;INVERT a square field of pixels
;       CALL    $00AB           ;DRAW DOTTED SQUARE
;       CALL    $00AE           ;DRAW DOTTED FILLED (CHECKERBOARD) SQUARE
;       CALL    $00B1           ;DRAW LINE FROM X1,Y1 TO X2,Y2
;       CALL    $00B7   	;Draw a circle from ceter to radius
;       CALL    $00E1   	;Draw a filled circle from center to radius
;       CALL    $00BD           ;Sets security lock to the unit
;       CALL    $0021  		;Turn on/off the backlight (LD A,$00 or $01)
;       CALL    $002D  		;Go into POWER DOWN mode
;       CALL    $0041       	;SET TIME ???
;       CALL    $0044       	;SET DATE ???
;------------------------------------------------------------------------------------
;

DRAWLINE: 
	LD      A,$00                   ; 06FF 3E00     >.	;TURN PIXELS OFF = 00
DL0:    LD      L,A                     ; 0701 6F       o	;TURN PIXELS ON = 01
        LD      H,$00                   ; 0702 2600     &.
        PUSH    HL                      ; 0704 E5       .
        LD      A,(YBOT)                ; 0705 3E0C     >.	;Y POSITION OF LOWER RH PIXEL?
        LD      L,A                     ; 0707 6F       o
        LD      H,$00                   ; 0708 2600     &.
        PUSH    HL                      ; 070A E5       .	
        LD      A,(XBOT)                ; 070E 7D       }	;X POSITION OF LOWER RH PIXEL?
        LD      L,A                     ; 070F 6F       o
        LD      H,$00                   ; 0710 2600     &.
        PUSH    HL                      ; 0712 E5       .
	LD	A,(YTOP)
        LD      E,A                     ; 0713 1E00     ..	;Y POSITION OF UPPER LH PIXEL?
	LD	A,(XTOP)
        LD      L,A                     ; 0715 2E00     ..	;X POSITION OF UPPER LH PIXEL?
        CALL    $00B1                   ; 0717 CD9600   ...
        POP     BC                      ; 071A C1       .
        POP     BC                      ; 071B C1       .
        POP     BC                      ; 071C C1       .
	RET
;
;------------------------------------------------------------------------------------
;	This routine will DRAW an unfilled circle from X,Y (Center) out
;	to a given radius of pixels on the Avigo screen
;------------------------------------------------------------------------------------
;
DRAW_CIRCLE:
        LD      A,$00                   ; 0705 3E0C     >.	;LINE TYPE $00 = FULL LINE
        LD      L,A                     ; 0707 6F       o	;	   $01 = DOTTED
        LD      H,$00                   ; 0708 2600     &.
        PUSH    HL                      ; 070A E5       .	
        LD      A,(XBOT)                ; 070E 7D       }	;RADIUS OF THE CIRCLE
        LD      L,A                     ; 070F 6F       o
        LD      H,$00                   ; 0710 2600     &.
        PUSH    HL                      ; 0712 E5       .
	LD	A,(YTOP)
        LD      E,A                     ; 0713 1E00     ..	;Y POSITION OF CENTER?
	LD	A,(XTOP)
        LD      L,A                     ; 0715 2E00     ..	;X POSITION OF CENTER?
        CALL    $00B7                   ; 0717 CD9600   ...
        POP     BC                      ; 071A C1       .
        POP     BC                      ; 071B C1       .
	RET
;
;
;------------------------------------------------------------------------------------
;	This routine will DRAW a filled circle from X,Y (Center) out
;	to a given radius of pixels on the Avigo screen
;------------------------------------------------------------------------------------
;
SOLID_CIRCLE:
        LD      A,(YBOT)                ; 0705 3E0C     >.	;LINE TYPE $00 = FILL SOLID
        LD      L,A                     ; 0707 6F       o	;	   $01 = FILL PATERN
        LD      H,$00                   ; 0708 2600     &.
        PUSH    HL                      ; 070A E5       .	
        LD      A,(XBOT)                ; 070E 7D       }	;RADIUS OF THE CIRCLE
        LD      L,A                     ; 070F 6F       o
        LD      H,$00                   ; 0710 2600     &.
        PUSH    HL                      ; 0712 E5       .
	LD	A,(YTOP)
        LD      E,A                     ; 0713 1E00     ..	;Y POSITION OF CENTER?
	LD	A,(XTOP)
        LD      L,A                     ; 0715 2E00     ..	;X POSITION OF CENTER?
        CALL    $00E1                   ; 0717 CD9600   ...
        POP     BC                      ; 071A C1       .
        POP     BC                      ; 071B C1       .
	RET
;
;------------------------------------------------------------------------------------
;	This routine will SCROLL to the left a WINDOW from X,Y (Upper LH) 
;	to X,Y (Lower RH) by a certain number pixels on the Avigo screen
;
;       CALL    $00A8           ;SCROLL right a certain number of pixels
;       CALL    $009F           ;SCROLL up a certain number of pixels
;------------------------------------------------------------------------------------
;
SCROLL_LEFT:
	LD      A,$02                   ; 06FF 3E00     >.	;HOW MANY PIXELS TO SCROLL
  	LD      L,A                     ; 0701 6F       o	
        LD      H,$00                   ; 0702 2600     &.
        PUSH    HL                      ; 0704 E5       .
        LD      A,(YBOT)                ; 0705 3E0C     >.	;Y POSITION OF LOWER RH PIXEL?
        LD      L,A                     ; 0707 6F       o
        LD      H,$00                   ; 0708 2600     &.
        PUSH    HL                      ; 070A E5       .	
        LD      A,(XBOT)                ; 070E 7D       }	;X POSITION OF LOWER RH PIXEL?
        LD      L,A                     ; 070F 6F       o
        LD      H,$00                   ; 0710 2600     &.
        PUSH    HL                      ; 0712 E5       .
	LD	A,(YTOP)
        LD      E,A                     ; 0713 1E00     ..	;Y POSITION OF UPPER LH PIXEL?
	LD	A,(XTOP)
        LD      L,A                     ; 0715 2E00     ..	;X POSITION OF UPPER LH PIXEL?
        CALL    $00A5                   ; 0717 CD9600   ...
        POP     BC                      ; 071A C1       .
        POP     BC                      ; 071B C1       .
        POP     BC                      ; 071C C1       .
	RET
;
;
;------------------------------------------------------------------------------------
;	This routine will SCROLL up a WINDOW from X,Y (Upper LH) 
;	to X,Y (Lower RH) by a certain number pixels on the Avigo screen
;
;------------------------------------------------------------------------------------
;
SCROLL_UP:
	LD      A,$02                   ; 06FF 3E00     >.	;HOW MANY PIXELS TO SCROLL
  	LD      L,A                     ; 0701 6F       o	
        LD      H,$00                   ; 0702 2600     &.
        PUSH    HL                      ; 0704 E5       .
        LD      A,(YBOT)                ; 0705 3E0C     >.	;Y POSITION OF LOWER RH PIXEL?
        LD      L,A                     ; 0707 6F       o
        LD      H,$00                   ; 0708 2600     &.
        PUSH    HL                      ; 070A E5       .	
        LD      A,(XBOT)                ; 070E 7D       }	;X POSITION OF LOWER RH PIXEL?
        LD      L,A                     ; 070F 6F       o
        LD      H,$00                   ; 0710 2600     &.
        PUSH    HL                      ; 0712 E5       .
	LD	A,(YTOP)
        LD      E,A                     ; 0713 1E00     ..	;Y POSITION OF UPPER LH PIXEL?
	LD	A,(XTOP)
        LD      L,A                     ; 0715 2E00     ..	;X POSITION OF UPPER LH PIXEL?
        CALL    $009F                   ; 0717 CD9600   ...
        POP     BC                      ; 071A C1       .
        POP     BC                      ; 071B C1       .
        POP     BC                      ; 071C C1       .
	RET
;
;
;------------------------------------------------------------------------------------
;	This routine will DISPLAY an ASCII message
;	to the Avigo screen
;
;	LD	L,$00
;	CALL	$00D5		;SETS TEXT MODE
;				;LD  L,$00 = NORMAL TEXT
;				;LD  L,$01 = BOLD TEXT
;				;LD  L,$20 = BIG TEXT
;				;LD  L,$21 = BOLD/BIG TEXT
;
;------------------------------------------------------------------------------------
;
PUTSCR: LD      A,$00                   ; 072A 3E00     >.	;TURN PIXELS OFF = 00
PUTS0:  LD      L,A                     ; 072C 6F       o	;TURN PIXELS ON = 01
        LD      H,$00                   ; 072D 2600     &.
        PUSH    HL                      ; 072F E5       .
	LD      HL,(POINTER)            ; 0730 21F174   !.t	;POINTER TO MESSAGE
        PUSH    HL                      ; 0733 E5       .
	LD	A,(YTOP)
        LD      E,A                     ; 0734 1E00     ..	;Y POSITION OF STARTING PIXEL
	LD	A,(XTOP)
        LD      L,A                     ; 0736 2E0E     ..	;X POSITION OF STARTING PIXEL
        CALL    $00CF                   ; 0738 CDCF00   ...
        POP     BC                      ; 073B C1       .
        POP     BC                      ; 073B C1       .
        LD      L,$00                   ; 07B5 2E00     ..
        CALL    $00D5                   ; 07B7 CDD500   ...
	RET
;
;
;------------------------------------------------------------------------------------
;	This routine will wait for a KEYPRESS/PENPRESS
;
;		02 = ADDRESS KEY
;		03 = SCHEDULE KEY
;		04 = TODO KEY
;		05 = MEMO KEY
;		06 = PAGEUP KEY
;		07 = PAGEDN KEY
;		08 = CALENDAR KEY
;		0A = CALC KEY
;		09 = EXPENSE KEY
;		0B = DATA KEY
;		0C = APPS KEY
;		0D = FIND KEY
;
;		FF = SCREEN PRESS (Now REG BC is valid) 
;
;			REG B = X POSITION OF PEN
;			REG C = Y POSITION OF PEN
;
;------------------------------------------------------------------------------------
;
GETKEY: CALL    $00E7                   ; 3ED1 CDE700   ...
        OR      A                       ; 3ED4 B7       .
        JR      Z,GETKEY                ; 3ED5 28FA     (.
        RET                             ; 3ED7 C9       .
;
;------------------------------------------------------------------------------------
;
;
;------------------------------------------------------------------------------------
;	P U T    B O X
;
;  This is the first of my own routines. This routine will clear an area and
;  then put up a dialog box with an OK button in it. The size and location
;  are fixed as is the location of the button.
;
;------------------------------------------------------------------------------------
;
PUTBOX:
	LD	A,$0B
	LD	(XTOP),A
	LD	A,$1F
	LD	(YTOP),A
	LD	A,$95
	LD	(XBOT),A
	LD	A,$99
	LD	(YBOT),A
	CALL	CLRPIX

	LD	A,$04			;Set the four corner radius' for the box
	LD	(XBOT),A		
	LD	A,$24
	LD	(YTOP),A
	LD	A,$10
	LD	(XTOP),A	
	CALL	DRAW_CIRCLE
	LD	A,$24
	LD	(YTOP),A
	LD	A,$90
	LD	(XTOP),A	
	CALL	DRAW_CIRCLE
	LD	A,$94
	LD	(YTOP),A
	LD	A,$10
	LD	(XTOP),A	
	CALL	DRAW_CIRCLE
	LD	A,$94
	LD	(YTOP),A
	LD	A,$90
	LD	(XTOP),A	
	CALL	DRAW_CIRCLE

	LD	A,$12			;Clear out 3 rectangles for the box
	LD	(XTOP),A
	LD	A,$90
	LD	(YTOP),A
	LD	A,$8E
	LD	(XBOT),A
	LD	A,$98
	LD	(YBOT),A
	CALL	CLRPIX
	LD	A,$12
	LD	(XTOP),A
	LD	A,$20
	LD	(YTOP),A
	LD	A,$8E
	LD	(XBOT),A
	LD	A,$28
	LD	(YBOT),A
	CALL	CLRPIX
	LD	A,$0C
	LD	(XTOP),A
	LD	A,$26
	LD	(YTOP),A
	LD	A,$94
	LD	(XBOT),A
	LD	A,$92
	LD	(YBOT),A
	CALL	CLRPIX

	LD	A,$10			;Setup the 4 lines that make the box
	LD	(XTOP),A
	LD	A,$20
	LD	(YTOP),A
	LD	A,$90
	LD	(XBOT),A
	LD	A,$20
	LD	(YBOT),A
	CALL	DRAWLINE
	LD	A,$94
	LD	(XTOP),A
	LD	A,$24
	LD	(YTOP),A
	LD	A,$94
	LD	(XBOT),A
	LD	A,$94
	LD	(YBOT),A
	CALL	DRAWLINE
	LD	A,$8E
	LD	(XTOP),A
	LD	A,$98
	LD	(YTOP),A
	LD	A,$12
	LD	(XBOT),A
	LD	A,$98
	LD	(YBOT),A
	CALL	DRAWLINE
	LD	A,$0C
	LD	(XTOP),A
	LD	A,$92
	LD	(YTOP),A
	LD	A,$0C
	LD	(XBOT),A
	LD	A,$26
	LD	(YBOT),A
	CALL	DRAWLINE

	LD	A,$10			;Setup the grey boarders
	LD	(XTOP),A
	LD	A,$96
	LD	(YTOP),A
	LD	A,$90
	LD	(XBOT),A
	LD	A,$97
	LD	(YBOT),A
	CALL	DRAW_GREY
	LD	A,$92
	LD	(XTOP),A
	LD	A,$26
	LD	(YTOP),A
	LD	A,$93
	LD	(XBOT),A
	LD	A,$96
	LD	(YBOT),A
	CALL	DRAW_GREY

	LD	A,$0C			;Set the icon circle
	LD	(XBOT),A	
	LD	A,$38
	LD	(YTOP),A
	LD	A,$26
	LD	(XTOP),A	
	CALL	DRAW_CIRCLE

	LD	L,$21			;Setup "!" in the icon circle
	CALL	$00D5
	LD	HL,SY1			
	LD	(POINTER),HL
	LD	A,$32
	LD	(YTOP),A
	LD	A,$24
	LD	(XTOP),A	
	CALL	PUTSCR

	LD	A,$07			;Setup OK circles
	LD	(XBOT),A		
	LD	A,$88
	LD	(YTOP),A
	LD	A,$3C
	LD	(XTOP),A	
	CALL	DRAW_CIRCLE
	LD	A,$88
	LD	(YTOP),A
	LD	A,$65
	LD	(XTOP),A	
	CALL	DRAW_CIRCLE

	LD	A,$3C			;Clear area between OK circles
	LD	(XTOP),A
	LD	A,$80
	LD	(YTOP),A
	LD	A,$65
	LD	(XBOT),A
	LD	A,$8F
	LD	(YBOT),A
	CALL	CLRPIX

	LD	A,$3C			;Draw lines for OK Button
	LD	(XTOP),A
	LD	A,$80
	LD	(YTOP),A
	LD	A,$65
	LD	(XBOT),A
	LD	A,$80
	LD	(YBOT),A
	CALL	DRAWLINE
	LD	A,$3C
	LD	(XTOP),A
	LD	A,$90
	LD	(YTOP),A
	LD	A,$65
	LD	(XBOT),A
	LD	A,$90
	LD	(YBOT),A
	CALL	DRAWLINE

	LD	L,$01
	CALL	$00D5
	LD	HL,SY2			;Setup the OK text
	LD	(POINTER),HL
	LD	A,$83
	LD	(YTOP),A
	LD	A,$48
	LD	(XTOP),A	
	CALL	PUTSCR
	RET
;
SY1:   .BYTE "!",0
SY2:   .BYTE "OK",0
;
;------------------------------------------------------------------------------------
;	C H E C K   O K
;
;------------------------------------------------------------------------------------
;
CHECK_OK:
	CALL	$00E7
	CP	$FF
	JR	NZ,CHK1
	LD	A,B		;X POSITION OF PEN
	CP	$3C
	JR	C,CHK1
	CP	$65
	JR	NC,CHK1
	LD	A,C		;Y POSITION OF PEN
	CP	$80
	JR	C,CHK1
	CP	$90
	JR	NC,CHK1

	LD	A,$3C		;Setup INVERT of OK field
	LD	(XTOP),A
	LD	A,$81
	LD	(YTOP),A
	LD	A,$65
	LD	(XBOT),A
	LD	A,$8F
	LD	(YBOT),A
	CALL	INVERT_PIX
	LD	A,$07		;Setup INVERT of OK circles
	LD	(XBOT),A
	LD	A,$00
	LD	(YBOT),A		
	LD	A,$88
	LD	(YTOP),A
	LD	A,$3C
	LD	(XTOP),A	
	CALL	SOLID_CIRCLE
	LD	A,$88
	LD	(YTOP),A
	LD	A,$65
	LD	(XTOP),A	
	CALL	SOLID_CIRCLE
CHK2:	CALL	$00E7
	CP	$FF
	JR	Z,CHK2
	LD	A,$FF
	JR	CHK3	
CHK1:	LD	A,$00
CHK3:	LD	(XTOP),A
	LD	L,$00
	CALL	$00D5
	LD	A,(XTOP)
	RET
;
;------------------------------------------------------------------------------------
;
;This is the end of the program code...
;

HEXTABLE
	.byte "0123456789ABCDEF"
TITLE:	.byte "Memory Show......",0
MS01:	.byte "Press PGUP and PGDN to view",0
MS02:	.byte "Press ADDRESS key to exit",0
MS03:	.byte "Memory",0
MS07:	.byte "Show",0
MS04:	.byte "A memory viewing",0
MS05:   .byte "program by:",0
MS06:	.byte "Ray Broniak",0
;
	.byte	0FFH,0FFH,0FFH,0FFH		;Pad with $FF's
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
;
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
;
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
;
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
;
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
;
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
;
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
;
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
;
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
;
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
;
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH
;
	.byte	0FFH,0FFH,0FFH,0FFH
	.byte	0FFH,0FFH,0FFH,0FFH

	.ORG 	$007FC0

	.byte	0FFH,0FFH

;
	.end					;End of program

